/*
 * uni_calc_meta.c
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "libuni.h"

/* uni_calc_meta : Returns 0 on successful completion. */
int
uni_calc_meta (struct unifile *ufile)
{
	int i;
	long int elems;
	double max, min;
	double val;
	double *the_data;

	if (ufile[0].data == NULL)
		{
			fprintf (stderr, "ERROR! Null data array\n");
			return 1;
		}

	the_data = ufile[0].data;

	ufile[0].xn = ufile[0].x1 + (ufile[0].num_elems - 1)*ufile[0].dx;

	max = -1e10;
	min = 1e10;
	
	elems = ufile[0].num_elems;

	for (i = 0; i < elems; i++)
		{
			val = the_data[i];
			if (val > max)
				{
					max = val;
				}
			if (val < min)
				{
					min = val;
				}
		}

	ufile[0].ymin = min;
	ufile[0].ymax = max;
	return 0;
}
