/*
 * uni_find_data.c
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>
#include "libuni.h"

/* uni_find_data : Returns 0 on successful completion. */
int
uni_find_data (FILE *fp, int *pos)
{
	int result;
	int i;
	long int bytes;
	char *buf;

	pos[0] = -1;

	/* Rewind file to end */
	result = fseek (fp, 0L, SEEK_END);
	if (result)
		{
			/* Error reading file! ERROR Code: 1 */
			return 1;
		}

	bytes = ftell(fp);

	/* result holds # of bytes */

	buf = (char *) malloc (sizeof (char) * bytes);

	result = fseek (fp, 0L, SEEK_SET);
	
	if (result)
		{
			/* Error reading file! ERROR Code: 2 */
      free (buf);
			return 2;
		}

	result = fread (buf, bytes, 1, fp);
	
	if (result != 1)
		{
			/* Error reading file into array! ERROR Code: 3 */
      free (buf);
			return 3;
		}

	for (i = 0; i < bytes - 4; i++)
		{
			if (buf[i] == '#')
				{
					i++;
					if (buf[i] == '^')
						{
							i++;
							if (buf[i] == 13)
								{
									i++;
									if (buf[i] == 10)
										{
											/* Offset to seek to in order to read first byte */
											pos[0] = i+1;
											break;
										}
								}
						}
				}
		}
	
	if (pos[0] == -1)
		{
			/* Error unable to find delimiter! ERROR Code: 4 */
      free (buf);
			return 4;
		}

  free (buf);
	return 0;
}
