#include "libuni.h"

int
uni_normalize_to (struct unifile *ref_ufile, struct unifile *ufile, double minwvl, double maxwvl)
{
  int i;
  int firstr, lastr;
  int first, last;

  char key[68];

  double avr, av;
  double totalr, total;
  double sf;

  firstr = (int)((minwvl - ref_ufile->x1)/(ref_ufile->dx));
  first  = (int)((minwvl - ufile->x1)/(ufile->dx));
  lastr  = (int)((maxwvl - ref_ufile->x1)/(ref_ufile->dx)) + 1;
  last   = (int)((maxwvl - ufile->x1)/ufile->dx) + 1;

  if (firstr < 0 || first < 0)
    {
      fprintf (stderr, "ERROR: uni_normalize_to.c: first or firstr negative\n");
      return 1;
    }
  if (lastr >= ref_ufile->num_elems || last >= ufile->num_elems)
    {
      fprintf (stderr, "ERROR: uni_normalize_to.c: last or lastr too big\n");
      return 1;
    }

  totalr = 0;
  for (i = 0; i <= lastr - firstr; i++)
    totalr += ref_ufile->data[firstr + i];
  total = 0;
  for (i = 0; i <= last - first; i++)
    total += ufile->data[first+i];

  avr = totalr/(double)((lastr-firstr+1));
  av  = total/(double)((last - first + 1));

  sf = avr/av;

  #ifdef _DEBUG
  fprintf (stderr, "Average of ref, spec: %e, %e sf: %e\n", avr, av, sf);
  #endif


  for (i = 0; i < ufile->num_elems; i++)
    ufile->data[i] *= sf;

  uni_calc_meta (ufile);

  // sprintf (key, "%le", sf);

  // uni_writekey (key, "SCALEF", ufile);

  return 0;
}
    
