/*
 * uni_read_data.c
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "libuni.h"

/* uni_read_data : Returns 0 on successful completion. */
int
uni_read_data (FILE *fp, double **data, long int *num_elems)
{
	int result;
	int pos;
	int i;
	long int bytes;
	long int elems_read;
	float *dataf;

	/* Get file size */
	result = fseek (fp, 0L, SEEK_END);

	if (result) /* Problem seeking - ERROR Code: 1 */
		return 1;
	
	bytes = ftell(fp);

	result = uni_find_data(fp, &pos);

	if (result)
		{
			/* Problem with uni_find_data - ERROR Code: 2 */
			fprintf (stderr, "uni_find_data returned error code %d\n", result);
			return 2;
		}

	/* Pos is the byte offset to seek to in order to begin reading the data. */
	result = fseek (fp, pos, SEEK_SET);

	if (result) /* Problem seeking - ERROR Code: 3 */
		return 3;

	bytes -= pos;
	num_elems[0] = bytes/4L;

	data[0] = (double *) malloc (sizeof (double) * num_elems[0]);
	
	dataf = (float *) malloc (sizeof (float) * num_elems[0]);

	elems_read = fread (dataf, 4, num_elems[0], fp);

	if (elems_read != num_elems[0])
		{
			/* Misread data - ERROR Code: 4 */
			fprintf (stderr, "uni_read_data:48 - fread returned %ld\n", elems_read);
			return 4;
		}

	for (i = 0; i < num_elems[0]; i++)
		{
			data[0][i] = dataf[i];
		}
	
	free(dataf);


	return 0;
}
