/*
 * uni_read_headerc
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "libuni.h"

/* uni_read_header: Returns 0 on successful completion. */
int
uni_read_header (FILE *fp, char **header, long int *bytes)
{
	
	/* Result for various functions */
	int result;

	/* Byte position in file */
	int pos;

	long int elems_read;

	/* Find the #^^M delimiter */
	result = uni_find_data(fp, &pos);

	/* We came across an error */
	if (result)
		{
			/* Problem with uni_find_data - ERROR Code: 1 */
			#ifdef _DEBUG
			fprintf (stderr, "ERROR: uni_read_header.c - uni_find_data returned error code %d\n", result);
			#endif
			return 1;
		}

	/* Pos is the last byte of the header. */

	/* Go to the beginning of the file */
	result = fseek (fp, 0L, SEEK_SET);

	if (result) /* Problem seeking - ERROR Code: 2 */
		return 2;

	bytes[0] = pos;

	header[0] = (char *) malloc (bytes[0]);

	elems_read = fread (header[0], bytes[0], 1, fp);

	if (elems_read != 1)
		{
			/* Misread data - ERROR Code: 3 */
			#ifdef _DEBUG
			fprintf (stderr, "ERROR: uni_read_header.c - fread returned %ld\n", elems_read);
			#endif
			return 3;
		}

	return 0;
}
