#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libuni.h"

int
uni_readkey (char **var, const char *keyname, struct unifile *ufile)
{

	int i;
	int result;
	int length;
	int lines;
	int stridx;

	lines = ufile[0].header_lines;

	if (ufile[0].header == NULL || lines < 1)
		{
			#ifdef _DEBUG
			fprintf (stderr, "ERROR: uni_readkey.c - header empty.\n");
			#endif
			return 1;
		}

	/* Check for existence of key, and find location */
	result = uni_findkey (keyname, ufile);
	
	if (result < 0)
		{
			/* Key does not exist */
			#ifdef _DEBUG
			fprintf (stderr, "ERROR: uni_readkey.c - uni_findkey returned %d\n", result);
			#endif
			return 2;
		}

	/* Now we step through the line of the header, looking for the '=  ' */
	length = strlen (ufile[0].header[result]);
	stridx = -1;
	for (i = 0; i < length; i++)
		{
			if (ufile[0].header[result][i] == '=')
				{
						/* We got it */
						stridx = i; /* Start of var string */
				}
		}
	
	if (stridx == -1)
		{
			/* We didn't find anything */
			#ifdef _DEBUG
			fprintf (stderr, "ERROR: uni_readkey.c - key exists, but can't read?\n");
			#endif
			return 3;
		}

	length = strlen (ufile[0].header[result] + stridx+1);

	*var = (char *) malloc (sizeof (char) * (length + 1));
	
	if (*var == NULL)
		{
			#ifdef _DEBUG
			fprintf (stderr, "ERROR: uni_readkey.c - malloc failed for var \n");
			#endif
			return 4;
		}

	strcpy (*var, ufile[0].header[result] + stridx + 1);

	return 0;

}
