/*
 * uni_write_data.c
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "libuni.h"

/* uni_write_data : Returns 0 on successful completion. */
int
uni_write_data (FILE *fp, double *data, long int num_elems)
{
	int i;
	long int elems_written;
	float *temp;
	
	temp = (float *) malloc (sizeof (float) * num_elems);

	for (i = 0; i < num_elems; i++)
		{
			temp[i] = data[i];
		}

	elems_written = fwrite (temp, 4, num_elems, fp);

	free (temp);

	if (elems_written != num_elems)
		{
			fprintf (stderr, "uni_write_data.c:18 fwrite returned %ld\n", elems_written);
			return 1; /* Can't write data elements */
		}
	return 0;
}
