/*
 * uni_write_header.c
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "libuni.h"

/* uni_write_header : Returns 0 on successful completion. */
int
uni_write_header (FILE *fp, char *header, long int bytes)
{
	int result;
	long int elems_written;

	result = fseek (fp, 0, SEEK_SET);

	if (result)
		{
			/* Problem seeking */
			return 1;
		}
	elems_written = fwrite (header, bytes, 1, fp);

	if (elems_written != 1)
		{
			fprintf (stderr, "uni_write_header.c:25 fwrite returned: %ld\n", elems_written);
			return 2; /* Can't write header */
		}
	
	return 0;
}
