#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libuni.h"

int
uni_writekey (char *var, const char *keyname, struct unifile *ufile)
{

	int result;
	int lines;
	int keylen, varlen;
	char **header;

	lines = ufile[0].header_lines;
	header = ufile[0].header;

	if (lines != 0 && header != NULL)
		{
			/* We're not adding the first line.. */
			
			result = uni_iskey (keyname, ufile);

			if (result)
				{
					/* Key exists */
					result = uni_deletekey (keyname, ufile);
				}
		}


	header = (char **) realloc (header, (lines+1)*sizeof (char **));

	keylen = strlen (keyname);
	varlen = strlen (var);

	header[lines] = (char *) malloc (sizeof (char)* (keylen+varlen+5));

	sprintf (header[lines], "#%s=  %s", keyname, var);

	ufile[0].header = header;
	ufile[0].header_lines = lines + 1;

	return 0;

}
